package vishnu.datablock;
import java.io.*;

public class SparseNode implements Serializable
{
    private float value;
    
    private int column;
    private SparseNode next;
    
    
    SparseNode(float f, int c)
    {
	value = f;
	column = c;
	next = null;
    }
    
    
    SparseNode(float f, int c, SparseNode n)
    {
	value = f;
	column = c;
	next = n;
    }
    

    public SparseNode push(SparseNode n)
    {
        if (next != null) next.push(n);
        else next = n;
        return this;
    }


    public SparseNode pop()
    {
	return next;
    }

    
    public SparseNode getNext()
    {
        return next;
    }

    
    public int getColumn()
    {
        return column;
    }
    

    public float getValue()
    {
        return value;
    }
}

