package vishnu.testvis.visual;

import java.util.*;
import java.net.*;
import java.io.*;
import java.lang.*;
import java.util.zip.*;

class HitCluster
{
    static final int NOVALUE = 99999999;
    static int MAX;
    static final int EMPTYARRAY[] = {};
    static int matrix[][];
    // static int data[][];
    static float data [][];
    static int clusters[][];
    static int keywords[];
    static int maxDocuments;

    static void buildMatrix ()
    {
	    int count;
	    int keyword1, keyword2;
    	matrix = new int[MAX][MAX];
        for (int word1=0;word1<MAX;word1++)
        {
	        keyword1 = keywords[word1];
	        for (int word2=word1+1; word2<MAX;word2++)
            {
 		        keyword2 = keywords[word2];
                count = 0;
                for (int doc=0;doc<maxDocuments;doc++)
                {
		            if ( (data[doc][keyword1] > 0) && (data[doc][keyword2] > 0))
			            count++;
	            }
                matrix[word1][word2]=matrix[word2][word1]=count;
            }
        }
	    for (int row = 0;row <MAX; row++)
	    {
	        matrix[row][row] = NOVALUE;
	        for (int col = 0; col <row; col++)
		    matrix[row][col] = matrix[col][row];
	    }
    }

    static void findLargest ()
    {
	    int group = matrix[0].length-1;
	    int largest = -1;
	    int smallRow = NOVALUE;
	    int smallCol = NOVALUE;
	    int row,col;
	    for (row =0; row<MAX; row++)
	        for (col=row+1; col<MAX; col++)
	            if (largest < matrix[row][col])
	            {
		            largest = matrix[row][col];
		            smallRow = row;
		            smallCol = col;
 	            }
	    for (col=0; col<MAX; col++)
	    {
	        if (matrix[smallRow][col] > matrix[smallCol][col])
		        matrix[smallRow][col] = matrix[smallCol][col];
            matrix[smallCol][col] = -1;
	    }
	    clusters[smallRow] = addClusters(smallRow, smallCol);
	    clusters[smallCol] = EMPTYARRAY;
	    for (row =0; row<MAX; row++)
        {
	        matrix[row][smallCol] = -1;
            matrix[row][smallRow] = matrix[smallRow][row];
	    }
    }

    static int[] addClusters(int c1, int c2)
    {
	    int i;
	    int temp[] = new int[clusters[c1].length+clusters[c2].length];
	    if (keywords[clusters[c1][0]] < keywords[clusters[c2][0]])
	    {
	        for (i = 0; i<clusters[c1].length;i++)
	    	    temp[i] = clusters[c1][i];
	        for (i = 0; i<clusters[c2].length;i++)
	    	    temp[i+clusters[c1].length] = clusters[c2][i];
	    }
	    else
	    {
	        for (i = 0; i<clusters[c2].length;i++)
	    	    temp[i] = clusters[c2][i];
	        for (i = 0; i<clusters[c1].length;i++)
	    	    temp[i+clusters[c2].length] = clusters[c1][i];
	    }
	    return temp;
    }

    static void preClusters()
    {
	    clusters = new int[MAX][1];
	    for (int row =0; row <MAX; row++)
	    {
	        clusters[row][0] = row;
	    }
    }

    static int[] maximunDistance (float[][] newData, int[] newKeywords, int documentCount)
    {
	    data = newData;
	    keywords = newKeywords;
	    maxDocuments = documentCount;
	    if (documentCount > data.length)
	    {
	        System.out.println ("WARNING matrix sent is shorter the document Count!");
	        System.out.println ("I will use the shorter length only.");
	        documentCount = data.length;
        }
	    MAX = keywords.length;
	    buildMatrix();
	    preClusters();
	    for (int i=1;i<MAX;i++)
	    {
 	        findLargest();
        }
	    int temp[] = new int[MAX];
	    for (int i=0;i<MAX;i++)
	    {
	        temp[i] = keywords[clusters[0][i]];
//System.out.println (i+" = "+keywords[i]+" = "+clusters[0][i]);
    	}
	    return temp;
    }
}

